indexing
	descripcion: "Obtener un array ordenado que contenga todas las cadenas de caracteres que se leen de consola"
	version: "Ordenar después de insertados todos los elementos"
class ORDENAR_ARRAY
creation
	make
feature
	make is
	local
		a: ARRAY[STRING]

	do
		create a.make(1,0)

		-- Leer de consola
		from
			std_input.read_line
		until
			std_input.last_string.is_equal("")
		loop
			a.add_last(clone(std_input.last_string))
			std_input.read_line
		end


		imprimir_array(a)

		ordenar(a)

		std_output.put_new_line

		imprimir_array(a)

	end -- make

	imprimir_array(a: ARRAY[STRING]) is
	-- Imprime cada elemento del array en una línea
	local
		i : INTEGER
	do
		from
			 i := a.lower 
		until
			 i > a.upper  
		loop
			std_output.put_string(a@i) 
			std_output.put_new_line
			i := i + 1
		end
	end --imprimir_array

	ordenar(a: ARRAY[STRING]) is
	-- ordena los elementos del array en orden ascendente
	local
		i,j : INTEGER
		cadena: STRING
	do
		from
			i := a.lower
		until
			i > a.upper
		loop
			from
				j := i + 1
			until
				j > a.upper
			loop
				if a.item(i) > a.item(j) then
					a.swap(i,j)
					-- Version B
					--cadena := a@i -- a.item(i)
					--a.put(a@j, i)
					--a.put(cadena, j)

				end
				j := j + 1
			end
			i := i + 1
		end
	end --ordenar

end --class ORDENAR_ARRAY
