indexing
	descripcion: "A partir de una cadena con el formato de las líneas del fichero /etc/passwd, actualiza los datos de un usuario"
	se_basa: "Los datos del usuario son modelador por la clase USUARIO"
	comentario: "Se corresponde con un fragmento del enunciado de la práctica del curso 2005-2006"
class APLICACION
creation
	make
feature
	make is
	local
		linea : STRING
		u: USUARIO
	do
		-- lectura de la línea
		std_input.read_line
		linea := clone(std_input.last_string)
	
		-- Comprueba si tiene el mismo número de campos separados por ':' que una línea del fichero /etc/passwd
		if linea.occurrences(':')=6 then
			-- Crea un objeto de la clase USUARIO a partir de la cadena
			create u.make_from_string(linea)

			-- Realiza esta salida para comprobar
			std_output.put_string(u.nombre + " " + 
		       		              u.apellidos + ": " + 
					      u.tipo_de_usuario + "%N")
		else
			std_output.put_string("Error: Entrada no válida.%N")
		end
	end
end --class APLICACION
