indexing
	descripcion: "Enunciado 24 de la página de problemas. Se lee y se valida la hora en formato H:M:S"
	version: "Se controlan todos los casos de la entrada. Para ello se lee como cadena"
class HORAS
creation
	make
feature
	make is
	local
		h, m, s: INTEGER
		h_s, m_s, s_s: STRING

		hora_correcta, minutos_correctos, segundos_correctos: BOOLEAN
	do
		-- lectura
		std_output.put_string("Entre una hora: %N")
		std_input.read_word_using(":")

		h_s := clone(std_input.last_string)
		hora_correcta := h_s.is_integer

		std_input.read_word_using(":")
		m_s := clone(std_input.last_string)
		minutos_correctos := m_s.is_integer

		std_input.read_word_using("%N")
		s_s := clone(std_input.last_string)
		segundos_correctos := s_s.is_integer

		-- validacion
		if hora_correcta and minutos_correctos and segundos_correctos then
			h := h_s.to_integer
			m := m_s.to_integer
			s := s_s.to_integer

			hora_correcta := h.in_range(0,23)
			minutos_correctos := m.in_range(0,59)
			segundos_correctos := s.in_range(0,59)
		end

		-- respuesta
		if hora_correcta and minutos_correctos and segundos_correctos then
				std_output.put_string("OK!: " + h.to_string + ":" + m.to_string + ":" + s.to_string + "%N")
		else
			std_output.put_string("Error! %N")
			if not hora_correcta then
				std_output.put_string("-> horas incorrectas%N")
			end
			if not minutos_correctos then
				std_output.put_string("-> minutos incorrectos%N")
			end
			if not segundos_correctos then
				std_output.put_string("-> segundos incorrectos%N")
			end
		end
	end -- make
end --class HORAS
