indexing
	descripcion: "Salida similar a la utilidad wc de linux"
class WC
creation
make
feature
make is
local
	f : TEXT_FILE_READ
	palabras, lineas, caracteres: INTEGER
do
	create f.connect_to("pepe") -- conectar con el fichero físico

	from  
		f.read_character  -- Se lee a nivel de caracteres para poder controlar todos, separadores y no separadores.
				  -- Hay que intentar una lectura para saber si se ha llegado al final del fichero.
	until
		f.end_of_input    -- Indicación de final de fichero. Una vez obtenida esta señal, no se debe avanzar en la lectura
	loop
		-- Cuenta el caracter leido
		caracteres := caracteres + 1

	 	if  f.last_character = '%N' then
			-- Si es cambio de línea, cuenta una línea
			lineas := lineas + 1
		end

		if not f.last_character.is_separator then
			-- avanzar por una palabra contando los caracteres
			from
				f.read_character
			until
				f.end_of_input or f.last_character.is_separator
			loop
				-- Cuenta el caracter leido
				caracteres := caracteres + 1
				f.read_character
			end

			-- una vez terminada una palabra, la cuenta
			palabras := palabras + 1

			if f.last_character.is_separator then
				-- Cuenta el carácter separador al final de la palabra, que ya ha sido leido.
				caracteres := caracteres + 1
	 			if  f.last_character = '%N' then
					-- Si es el caso de que el separador era un cambio de línea, cuenta una línea
					lineas := lineas + 1
				end
			end
		end

		if not f.end_of_input then
			f.read_character   -- Avanza en la lectura. Tiene en cuenta la posibilidad de haber agotado el fichero
					   -- en el bucle interno que avanza sobre una palabra.
		end
	end

	-- Respuesta
	std_output.put_string("Lineas: " + lineas.to_string + " Palabras: " + palabras.to_string + " Caracteres: " + caracteres.to_string + "%N")

	f.disconnect  -- desconectar del fichero físico
end -- make
end -- class WC
