indexing
	descripcion: "Descomponer un nmero en sus factores primos"
class DIVISORES
creation
	make
feature
	make is
	-- mtodo de creacin de la clase raz. Por aqu comienzan las acciones.
	local
		numero: INTEGER
	do
		-- Leer
		std_output.put_string("Introduce un nmero entero >1 ")
		std_input.read_integer
		numero := std_input.last_integer
		-- Validar
		if numero >= 1 then
		-- Caso Positivo
			-- Comn: Imprimir nmero=1
			std_output.put_string(numero.to_string + "=1")
			-- Imprimir el resto de los factores primos
			divisores(numero)
		else
		-- Caso Negativo
			-- Informar y Terminar
			std_output.put_string("Error: Nmero <=1%N")
		end
	end

	divisores(n: INTEGER) is
	-- Imprime los factores primos del nmero mayores que 1
	local
		numero : INTEGER
		factor : INTEGER
	do
		-- Dividiendo el nmero por cada factor primo que
		-- se va encontrando, comenzando siempre por el menor.
		from
			numero := n -- inicializacin
		until
			numero = 1  -- condicin de terminacin
		loop
			-- Menor de los factores primos que lo dividen
			factor := menor_divisor(numero)
			-- Imprimir 
			std_output.put_string("*" + factor.to_string)
			numero := numero // factor -- modificar la variable de control
		end
		std_output.put_string("%N")
	end

	menor_divisor(n: INTEGER): INTEGER is
	-- obtiene el menor de los factores del nmero comenzando por 2.
	local
		i : INTEGER
	do
		from
			i := 2 -- inicializacin
		until
			(n \\ i) = 0 -- condicin de terminacin
		loop
			i := i + 1 -- modificar la variable de control
		end
		Result := i
 	end

end -- class DIVISORES
