indexing
	descripcion: "Compara cadenas sin importar mayúsculas y minúsculas: Case insensitive"
class COMPARAR_CADENAS_CASE_INSENSITIVE
creation
	make
feature
	make is
	local
		s, s1 : STRING
	
	do
		std_output.put_string("Introduzca cadena a comparar: %N")
		std_input.read_line
		s := clone(std_input.last_string) -- Tiene en cuenta hacer una copia con clone.
						  -- De lo contrario la cadena permanecería referenciando al último
						  -- string leido y por tanto resultará modificada en la siguiente lectura
		std_output.put_string("Introduzca la otra cadena a comparar: %N")
		std_input.read_line
		s1 := clone(std_input.last_string) -- Tiene en cuenta hacer una copia con clone.

		-- Compara teniendo en cuenta su secuencia de caracteres (por valor)
		if s.same_as(s1) then -- use is_equal for case sensitive
			std_output.put_string(s + " es igual a " + s1 + "%N")
		else
			std_output.put_string(s + " es distinto de " + s1 + "%N")
		end -- if s.same_as(s1)
	end -- make
end -- class COMPARAR_CADENAS_CASE_INSENSITIVE
