indexing
	descripcion: "Cuenta las palabras que se encuentran en un fichero."
	palabra: "Secuencia de caracteres en la que no se tiene ningún separador estándar"
	separador: "Separador estándar: espacio, tabulador y cambio de línea"
class WC_SOLO_PALABRAS
creation 
make
feature
make is
local
	f : TEXT_FILE_READ
	palabras: INTEGER
do
	create f.connect_to("pepe") -- conectar con el fichero físico

	from  
		f.read_word	-- comienza intentando leer. Primero siempre hay que intentar para saber si se ha llegado al final
	until
		f.end_of_input  -- indicación de fin de fichero. Cuando ya se tiene esta señal no se debe intentar otra lectura
	loop
		palabras := palabras + 1
		f.read_word -- avanza en la lectura de otra palabra
	end

	std_output.put_string("Palabras: " + palabras.to_string + "%N")

	f.disconnect -- desconectar del fichero físico
end
end -- class WC_SOLO_PALABRAS
