indexing
	descripcion: "Representa el conjunto de todos los usuarios del sistema"
class SISTEMA
creation
	make_from_file
feature
	usuarios: ARRAY[USUARIO]
feature
	make_from_file(f: TEXT_FILE_READ) is
	-- A partir de un fichero con el formato de /etc/passwd crea un listado
	-- de los usuarios del sistema
	require
		fichero_valido: f /= Void
		fichero_conectado: f.is_connected
	local
		linea: STRING
		u: USUARIO
	do
		-- Crear el array de usuarios
		create usuarios.make(1,0)

		from
			f.read_line
		until
			f.end_of_input
		loop
			linea := clone(std_input.last_string)
			create u.make_from_string(linea)
			usuarios.add_last(u)
			f.read_line
		end
	end -- make_from_file
end --class SISTEMA
